-- Test current_user_email
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

set search_path to camper, auth, public;

select plan(15);

select has_function('camper', 'current_user_email', array []::name[]);
select function_lang_is('camper', 'current_user_email', array []::name[], 'sql');
select function_returns('camper', 'current_user_email', array []::name[], 'text');
select isnt_definer('camper', 'current_user_email', array []::name[]);
select volatility_is('camper', 'current_user_email', array []::name[], 'stable');
select function_privs_are('camper', 'current_user_email', array []::name[], 'guest', array ['EXECUTE']);
select function_privs_are('camper', 'current_user_email', array []::name[], 'employee', array ['EXECUTE']);
select function_privs_are('camper', 'current_user_email', array []::name[], 'admin', array ['EXECUTE']);
select function_privs_are('camper', 'current_user_email', array []::name[], 'authenticator', array []::text[]);

set client_min_messages to warning;
truncate company_host cascade;
truncate company_user cascade;
truncate company cascade;
truncate auth."user" cascade;
reset client_min_messages;

insert into auth."user" (user_id, email, name, password, cookie, cookie_expires_at)
values (1, 'demo@tandem.blog', 'Demo', 'test', '44facbb30d8a419dfd4bfbc44a4b5539d4970148dfc84bed0e', current_timestamp + interval '1 month')
     , (5, 'admin@tandem.blog', 'Demo', 'test', '12af4c88b528c2ad4222e3740496ecbc58e76e26f087657524', current_timestamp + interval '1 month')
;

insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (2, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
     , (4, 'Company 4', 'XX234', '', '666-666-666', 'b@b', '', '', '', '', '', '', 60, 7, 'FR', 'USD', 'es')
;

insert into company_user (company_id, user_id, role)
values (2, 1, 'employee')
     , (4, 5, 'admin')
;

insert into company_host (company_id, host)
values (2, 'co2')
     , (4, 'co4')
;

select lives_ok(
	$$ select set_cookie('44facbb30d8a419dfd4bfbc44a4b5539d4970148dfc84bed0e/demo@tandem.blog', 'co2') $$,
	'Should change ok for the first user'
);

select is(current_user_email(), 'demo@tandem.blog', 'Should return the email of the first user');

reset role;


select lives_ok(
	$$ select set_cookie('12af4c88b528c2ad4222e3740496ecbc58e76e26f087657524/admin@tandem.blog', 'co4') $$,
	'Should change ok for the second user'
);

select is(current_user_email(), 'admin@tandem.blog', 'Should return the email of the second user');

reset role;

select lives_ok(
	$$ select set_cookie('', '') $$,
	'Should change ok for a guest user'
);

select is(current_user_email(), '', 'Should return an empty string');

reset role;


select *
from finish();

rollback;
